lint Helm Charts:
  image:
    name: alpine/helm
    entrypoint: ["/bin/sh", "-c"]
  stage: test
  script:
    - set +e
    - BASE_DIR=$PWD;
    - cd "$BASE_DIR/charts/efk" && helm dep up
    - cd "$BASE_DIR/charts/authf" && helm dep up
    - cd "$BASE_DIR/charts/iam-zen" && helm dep up
    - cd "$BASE_DIR/charts/purple-pie" && helm dep up
    - cd "$BASE_DIR/charts/electric-mail" && helm dep up
    - cd "$BASE_DIR/charts/microservice" && helm dep up
    - cd "$BASE_DIR/charts/swagger-combine-ui" && helm dep up
    - cd $BASE_DIR
    - helm lint charts/*
#    - helm lint charts/*/charts/*

deploy:
  image:
    name: cryptexlabs/helm-awscli:1.0.1
    entrypoint: ["/bin/sh", "-c"]
  stage: deploy
  environment:
    name: production
  script:
    - mkdir -p ./public/icons
    - helm repo add elastic https://helm.elastic.co
    - helm repo add fluent https://fluent.github.io/helm-charts
    - set +e
    - BASE_DIR=$PWD;
    - cd "$BASE_DIR/charts/efk" && helm dep up
    - cd "$BASE_DIR/charts/authf" && helm dep up
    - cd "$BASE_DIR/charts/iam-zen" && helm dep up
    - cd "$BASE_DIR/charts/purple-pie" && helm dep up
    - cd "$BASE_DIR/charts/electric-mail" && helm dep up
    - cd "$BASE_DIR/charts/microservice" && helm dep up
    - cd "$BASE_DIR/charts/swagger-combine-ui" && helm dep up
    - cd $BASE_DIR
    - mkdir -p ./public
    - aws s3 cp s3://helm.cryptexlabs.com/index.yaml index.yaml
    - helm package charts/* --destination ./public
    - helm repo index --url https://helm.cryptexlabs.com --merge index.yaml ./public
    - cp index.html ./public
    - BASE_DIR=$PWD; find charts -name 'icon.svg' -exec cp --parents \{\} $BASE_DIR/public/icons \;
    - BASE_DIR=$PWD; find charts -name 'icon.png' -exec cp --parents \{\} $BASE_DIR/public/icons \;
    - find ./public -name "*" -type f
    - aws s3 cp ./public s3://helm.cryptexlabs.com/ --recursive
    - aws s3 cp ./public/index.yaml s3://helm.cryptexlabs.com/index.yaml --content-type="text/yaml"
    - aws s3 cp ./artifacthub-repo.yml s3://helm.cryptexlabs.com/artifacthub-repo.yml --content-type="text/yaml"
    - aws s3 cp ./crds s3://helm.cryptexlabs.com/crds --recursive
    - aws cloudfront create-invalidation --distribution-id $CLOUDFRONT_DISTRIBUTION_ID --paths "/index.yaml"
  artifacts:
    paths:
      - public
  only:
    - master